/*
  libFTP.js 
  (c) Copyright 2016 Denis Sureau at Scriptol.com
  License MIT
  Use freely this code provided this license is included and unchanged
*/

var util = require("util")
var JSFtp = require("jsftp")

function beforeExit(dispCount) {
    process.on("exit", function() {
        dispCount()
        console.log("Done.")
    })
}


function getLFTime(fname) {
    var stats = fs.statSync(fname)
    var t = new Date(util.inspect(stats.mtime))
    
    var y = t.getFullYear()
    var m = "0" + t.getMonth()
    m = m.substr(-2) 
    var d = "0" + t.getMonth()
    d = d.substr(-2) 
    
    var hh = "0" + t.getHours()
    hh = hh.substr(-2) 
    var mm = "0" + t.getMinutes()
    mm = mm.substr(-2) 
    var ss = "0" + t.getSeconds()
    ss = ss.substr(-2) 
    
    return y + m + d + hh + mm + ss
}

/*
function ftpCopy(lfile, rfile, hdir) {
    if(CHECKMODE) {
        console.log("Must upload " + lfile + " to " + rfile)
        falsecounter += 1
        return
    }

    if(!QUIET) console.log("Uploading "+ lfile +" to "+ rfile + "\n")
    ftpSend(lfile, rfile, hdir, "", "")
}
*/

function localCopy(lfile, bfile, bdir) {
    try {
        var content = fs.readFileSync(lfile)
    }
    catch(e) {
        console.log("Enable to read " + lfile)
        return;
    }
    
    var res
    try {
        var stats = fs.statSync(bdir)
        res = true
    }
    catch(e) {
        res = false
    }
    
    if(!res || !stats.isDirectory()) {
        fs.mkdirSync(bdir)
    }
    
    try {
        fs.writeFileSync(bfile, content)        
    }
    catch(e) {
        console.log("Enable to write backup file " + bfile)
        return;
    }
}


function sendExit(src, loc, bdir) {
    COUNTER += 1
    if(BACKUP && loc != "") {
        localCopy(src, loc, bdir)
    }    
}

function notUploaded(err, src) {
    if(src == undefined) return
    ERRCOUNT += 1
    console.log("Error," +  src + " not uploaded. " + err)
}


function ftpSend(lfile, rfile, rdir, bfile,  bdir) {
    var connection = new JSFtp(OPTIONS)
    connection.put(lfile, rfile, function(err) {
        if (err)  {
            connection.raw.mkd(rdir, function(err, data) {
                connection.put(lfile, rfile, function(err) {
                    if(err) {
                        notUploaded()
                        return false
                    }    
                    connection.raw.quit(function() {
                        sendExit(lfile, bfile, bdir)
                    });
                    return false
                });    
            });
            return false
        }
        connection.raw.quit(function() {})
        sendExit(lfile, bfile, bdir)
    });    
    return true;        
}


function fileCopy(src,rmt,rdir,loc,bdir) {
    var p = new Promise(function (resolve) { 
        if(CHECKMODE===true) {
            console.log("Must upload "+src+" in "+rmt);
            falsecounter+=1;
            return;
        }
        if(QUIET===false) {
            process.stdout.write("Uploading "+src+" to "+rmt+"\n");
        }       
        resolve(ftpSend(src,rmt,rdir,loc,bdir));
   });
   return p;
}

process.on('uncaughtException', function (err) { })
