'use strict';

var Rx = require('rx');
var Net = require('net');
var RxNode = require('rx-node');

function fromFtpSocket(host, port) {
  var ftpSocket = Net.createConnection(port, host);
  var observable = RxNode.fromStream(ftpSocket);
  var observer = Rx.Observer.create(ftpSocket.send);

  return Rx.Subject.create(observer, observable);
}

module.exports = fromFtpSocket;

var s = fromFtpSocket('localhost', 21);

s.subscribe(function (out) {
  return console.log(out.toString());
});

s.onNext('SYST\r\n');