/* global FTP_PORT */
const Rx = require('rx');
const fromFtpSocket = require('fromFtpSocket');

class Ftp {
  constructor(options) {
    let port = this.port = options.port || FTP_PORT;
    let host = this.host = options.host;
    let connector$ = options.connector || fromFtpSocket;

    this.raw = () => runCmd.apply(this, arguments);

    this.connect(connector$, host, port);
  }

  connect(connector$, host, port) {
    let queue = this.cmdQueue$ = new Rx.Subject();
    let connection = this.connection$ = connector$(host, port);
    this.completed$ = Rx.Observable.zip(queue, connection);
  }

  runCmd(...args) {
    let callback = NOOP;
    let completeCmd = args.shift();

    if (typeof args[args.length - 1] === 'function') {
      callback = args.pop();
    }

    completeCmd += ' ' + args.join(' ');
    completeCmd = completeCmd.trim();

    this.connection$.onNext({
      cmd: completeCmd,
      callback
    });
  }
}

